=== debian/changelog ===
ceres-solver (2.1.0+really2.1.0+dfsg-2) unstable; urgency=medium

  * Honouring DEB_BUILD_OPTIONS=noopt by passing no CMAKE_BUILD_TYPE
    (Closes: #1041058)
  * Correcting dangling symlink creation in d/rules (Closes: #1042690)
  * Raising Standards version to 4.6.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Sun, 13 Aug 2023 21:57:27 +0200

ceres-solver (2.1.0+really2.1.0+dfsg-1) unstable; urgency=medium

  * Transition to SOVERSION 3

  [Pierre Gruet]
  * libatlas-base-dev has to be added as a dependency of the -dev package
  * Rewriting d/rules to run dh_sequences only once
  * Adding myself as uploader
  * New upstream version 2.1.0+really2.1.0+dfsg
  * Changing name of shared lib package to libceres3, following SOVERSION
  * Reverting install and docs paths at their state in version 2.1.0+dfsg
  * Installing the static lib in /usr/lib/$(DEB_HOST_MULTIARCH)
  * Adding a Lintian override for not providing a symbols file

  [Francois Mazen]
  * Fix malformed override lintian error

 -- Francois Mazen <francois@mzf.fr>  Fri, 24 Jun 2022 21:49:30 +0200
