=== debian/rules ===
--- 
+++ 
@@ -69,8 +69,11 @@
 	dh_compress -X.cc -X.h
 
 override_dh_auto_install:
+	# Installing the shared lib _after_ the static one is very important so that
+	# the remaining CeresTargets (and friends) files in /usr/lib/*/cmake/Ceres are
+	# allowing one to link with the shared lib of Ceres, not the static one.
+	dh_auto_install -B$(STATIC_LIB_PATH)
 	dh_auto_install -B$(SHARED_LIB_PATH)
-	dh_auto_install -B$(STATIC_LIB_PATH)
 
 override_dh_installdocs-indep:
 	# make lintian happy
@@ -87,6 +90,10 @@
 	ln -s /usr/share/javascript/sphinxdoc/1.0/language_data.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/language_data.js
 	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/searchtools.js
 	ln -s /usr/share/javascript/sphinxdoc/1.0/searchtools.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/searchtools.js
+	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/jquery.js
+	ln -s /usr/share/javascript/jquery/jquery.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/jquery.js
+	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/underscore.js
+	ln -s /usr/share/javascript/underscore/underscore.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/underscore.js
 	rm -rf $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/fonts
 	ln -s /usr/share/fonts/truetype/lato $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/fonts
 	dh_installdocs
